# Create UDisk - CreateUDisk

## Overview

Create UDisk Disk

 > 💡 17092": "The disk version is too low to enable UDataArk




## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `CreateUDisk`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.scloudsg.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Region** | string | Region. See [List of Regions and Availability Zones](/docs/api/summary/regionlist) |**Yes**|
| **Zone** | string | Availability Zone. See [Availability Zone List](/docs/api/summary/regionlist) |**Yes**|
| **ProjectId** | string | Project ID. If not filled in, the default project is used, sub-accounts must be filled in. Please refer to the [GetProjectList interface](/docs/api/summary/get_project_list). |No|
| **Size** | int | Purchase UDisk size, unit: GB, ordinary data disk: range [1\~8000]; SSD data disk, essential SSD data disk: range [1\~8000]; RSSD data disk, essential RSSD data disk: range [1\~32000]; High-efficiency data disk: range [1\~32000]. |**Yes**|
| **Name** | string | Instance Name |**Yes**|
| **ChargeType** | string | Yearly, Monthly, Dynamic, Postpay, Trial. The default is Dynamic. |No|
| **Quantity** | int | Purchase Duration Default: 1 |No|
| **UDataArkMode** | string | [Data Ark Access Has Been Disabled] Do you want to enable Data Ark? Yes: Enable, No: Disable, Default value: No |No|
| **SnapshotService** | string | Enable snapshot service (Enabling snapshot service allows free activation of UDataArk). Yes: Enable, No: Do not enable, Default value: No |No|
| **Tag** | string | Business Group Default: Default |No|
| **DiskType** | string | UDisk Type: DataDisk (Ordinary Data Disk), SSDDataDisk (SSD Data Disk), ESSDDataDisk (essential SSD Data Disk), RSSDDataDisk (RSSD Data Disk), ERSSDDataDisk (essential RSSD Data Disk), EfficiencyDataDisk (High Efficiency Data Disk), Default Value (DataDisk) |No|
| **UKmsMode** | string | Is it encrypted. Yes: Encrypted, No: Not encrypted, Default value (No) |No|
| **CmkId** | string | The CMK ID required for encryption, must be filled when UKmsMode is 'Yes'. |No|
| **RdmaClusterId** | string | RDMA cluster id. Can be filled when DiskType is RSSDDataDisk, specifying the creation of the cloud disk to the corresponding RDMA cluster. |No|
| **BackupMode** | string | Snapshot Service Backup Strategy. Standard Cloud Disk, SSD Cloud Disk, RSSD Cloud Disk Package Options: "Base": Basic Edition, "Ultimate": Flagship Edition, "Custom": Custom Backup Chain, default to Basic Edition package activation; ESSD Cloud Disk, ERSSD Cloud Disk Package: "Lite": Lite Edition, default to Lite Edition package activation. |No|
| **Journal** | int | When BackupMode is set to Custom, settings are made based on multiples of 12 hours in seconds, such as 12, 24, 36, 48. |No|
| **Hour** | int | When BackupMode is set to Custom, settings are made on a 24-hour basis and multiplied, such as 24, 48, 72, 96. |No|
| **Day** | int | When BackupMode is set to Custom, settings are made based on a multiple of 5 days, such as 5, 10, 15, 20, 25, 30. |No|
| **Labels** | string | User Labels |No|
| **CouponId** | string | ID of the voucher used |No|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **UDiskId** | array[string] | UDisk Instance Id |No|




## Example

### Request Example
    
```
https://api.scloudsg.com/?Action=CreateUDisk
&Region=cn-bj2
&Zone=cn-bj2-04
&Size=1
&Name=test_udisk
&UKmsMode=nVotfCwC
&UKmsMode=dETGTJcu
&CmkId=QimcSCvt
&IgnoreUBillInfo=ehrQXgoX
&UHostIdForAttachment=yIbJQDVn
&SnapshotService=VSFFRIXh
&RdmaClusterId=MBKDGzzF
&BackupMode=DvLHTYYK
&Journal=3
&Hour=1
&Day=9
&Labels=QCpOAKXa
&Labels=thUUtdAK
```

### Response Example
    
```json
{
  "Action": "CreateUDiskResponse",
  "RetCode": 0,
  "UDiskId": [
    "bs-xxx"
  ]
}
```





